Index: uspace/lib/c/generic/io/table.c
===================================================================
--- uspace/lib/c/generic/io/table.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/c/generic/io/table.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,565 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/**
+ * @file
+ * @brief Tabulate text
+ */
+
+#include <errno.h>
+#include <io/table.h>
+#include <stdarg.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+static table_column_t *table_column_first(table_t *);
+static table_column_t *table_column_next(table_column_t *);
+
+/** Add a new row at the end of the table.
+ *
+ * @param table Table
+ * @param rrow Place to store pointer to new row or @c NULL
+ *
+ * @return EOK on success, ENOMEM if out of memory
+ */
+static int table_add_row(table_t *table, table_row_t **rrow)
+{
+	table_row_t *row;
+
+	row = calloc(1, sizeof(table_row_t));
+	if (row == NULL)
+		return ENOMEM;
+
+	row->table = table;
+	list_initialize(&row->cells);
+	list_append(&row->ltable, &table->rows);
+
+	if (rrow != NULL)
+		*rrow = row;
+	return EOK;
+}
+
+/** Add a new cell at the end of the row.
+ *
+ * @param row Row
+ * @param rcell Place to store pointer to new cell or @c NULL
+ * @return EOK on success, ENOMEM if out of memory
+ */
+static int table_row_add_cell(table_row_t *row, table_cell_t **rcell)
+{
+	table_cell_t *cell;
+
+	cell = calloc(1, sizeof(table_cell_t));
+	if (cell == NULL)
+		return ENOMEM;
+
+	cell->text = NULL;
+
+	cell->row = row;
+	list_append(&cell->lrow, &row->cells);
+
+	if (rcell != NULL)
+		*rcell = cell;
+	return EOK;
+}
+
+/** Add a new column at the right side of the table.
+ *
+ * @param table Table
+ * @param rcolumn Place to store pointer to new column or @c NULL
+ *
+ * @return EOK on success, ENOMEM if out of memory
+ */
+static int table_add_column(table_t *table, table_column_t **rcolumn)
+{
+	table_column_t *column;
+
+	column = calloc(1, sizeof(table_column_t));
+	if (column == NULL)
+		return ENOMEM;
+
+	column->table = table;
+	column->width = 0;
+	list_append(&column->ltable, &table->columns);
+
+	if (rcolumn != NULL)
+		*rcolumn = column;
+	return EOK;
+}
+
+/** Start writing next table cell.
+ *
+ * @param table Table
+ * @return EOK on success, ENOMEM if out of memory
+ */
+static int table_write_next_cell(table_t *table)
+{
+	int rc;
+
+	rc = table_row_add_cell(table->wrow, &table->wcell);
+	if (rc != EOK) {
+		assert(rc == ENOMEM);
+		return rc;
+	}
+
+	if (list_count(&table->wrow->cells) == 1) {
+		/* First column */
+		table->wcolumn = table_column_first(table);
+	} else {
+		/* Next column */
+		table->wcolumn = table_column_next(table->wcolumn);
+	}
+
+	if (table->wcolumn == NULL) {
+		rc = table_add_column(table, &table->wcolumn);
+		if (rc != EOK) {
+			assert(rc == ENOMEM);
+			return rc;
+		}
+	}
+
+	return EOK;
+}
+
+/** Start writing next table row.
+ *
+ * @param table Table
+ * @return EOK on success, ENOMEM if out of memory
+ */
+static int table_write_next_row(table_t *table)
+{
+	int rc;
+
+	rc = table_add_row(table, &table->wrow);
+	if (rc != EOK) {
+		assert(rc == ENOMEM);
+		return rc;
+	}
+
+	table->wcell = NULL;
+	return EOK;
+}
+
+/** Get first table row.
+ *
+ * @param table Table
+ * @return First table row or @c NULL if none
+ */
+static table_row_t *table_row_first(table_t *table)
+{
+	link_t *link;
+
+	link = list_first(&table->rows);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, table_row_t, ltable);
+}
+
+/** Get next table row.
+ *
+ * @param cur Current row
+ * @return Next table row or @c NULL if none
+ */
+static table_row_t *table_row_next(table_row_t *cur)
+{
+	link_t *link;
+
+	link = list_next(&cur->ltable, &cur->table->rows);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, table_row_t, ltable);
+}
+
+/** Get first cell in table row.
+ *
+ * @param row Table row
+ * @return First cell in row or @c NULL if none
+ */
+static table_cell_t *table_row_cell_first(table_row_t *row)
+{
+	link_t *link;
+
+	link = list_first(&row->cells);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, table_cell_t, lrow);
+}
+
+/** Get next cell in table row.
+ *
+ * @param cur Current cell
+ * @return Next cell in table row or @c NULL if none
+ */
+static table_cell_t *table_row_cell_next(table_cell_t *cur)
+{
+	link_t *link;
+
+	link = list_next(&cur->lrow, &cur->row->cells);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, table_cell_t, lrow);
+}
+
+/** Get first table column.
+ *
+ * @param table Table
+ * @return First table column or @c NULL if none
+ */
+static table_column_t *table_column_first(table_t *table)
+{
+	link_t *link;
+
+	link = list_first(&table->columns);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, table_column_t, ltable);
+}
+
+/** Get next table column.
+ *
+ * @param cur Current column
+ * @return Next table column or @c NULL if none
+ */
+static table_column_t *table_column_next(table_column_t *cur)
+{
+	link_t *link;
+
+	link = list_next(&cur->ltable, &cur->table->columns);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, table_column_t, ltable);
+}
+
+/** Append to cell text.
+ *
+ * @param cell Cell
+ * @param str Text to append
+ * @param len Max number of bytes to read from str
+ * @return EOK on success, ENOMEM if out of memory
+ */
+static int table_cell_extend(table_cell_t *cell, const char *str, size_t len)
+{
+	char *cstr;
+	int rc;
+
+	if (cell->text == NULL) {
+		cell->text = str_ndup(str, len);
+		if (cell->text == NULL)
+			return ENOMEM;
+	} else {
+		rc = asprintf(&cstr, "%s%.*s", cell->text, (int)len, str);
+		if (rc < 0)
+			return ENOMEM;
+
+		free(cell->text);
+		cell->text = cstr;
+	}
+
+	return EOK;
+}
+
+/** Create table.
+ *
+ * @para, rtable Place to store pointer to new table.
+ * @return EOK on success, ENOMEM if out of memory
+ */
+int table_create(table_t **rtable)
+{
+	table_t *table;
+	int rc;
+
+	table = calloc(1, sizeof(table_t));
+	if (table == NULL)
+		return ENOMEM;
+
+	table->error = EOK;
+	list_initialize(&table->rows);
+	list_initialize(&table->columns);
+
+	rc = table_add_row(table, &table->wrow);
+	if (rc != EOK)
+		goto error;
+
+	rc = table_row_add_cell(table->wrow, &table->wcell);
+	if (rc != EOK)
+		goto error;
+
+	rc = table_add_column(table, &table->wcolumn);
+	if (rc != EOK)
+		goto error;
+
+	*rtable = table;
+	return EOK;
+error:
+	table_destroy(table);
+	return rc;
+}
+
+/** Destroy table.
+ *
+ * @param table Table
+ */
+void table_destroy(table_t *table)
+{
+	table_row_t *row;
+	table_cell_t *cell;
+	table_column_t *column;
+
+	if (table == NULL)
+		return;
+
+	row = table_row_first(table);
+	while (row != NULL) {
+		cell = table_row_cell_first(row);
+		while (cell != NULL) {
+			list_remove(&cell->lrow);
+			free(cell->text);
+			free(cell);
+			cell = table_row_cell_first(row);
+		}
+
+		list_remove(&row->ltable);
+		free(row);
+
+		row = table_row_first(table);
+	}
+
+	column = table_column_first(table);
+	while (column != NULL) {
+		list_remove(&column->ltable);
+		free(column);
+
+		column = table_column_first(table);
+	}
+
+	free(table);
+}
+
+/** Print out table contents to a file stream.
+ *
+ * @param table Table
+ * @param f File where to write the output
+ *
+ * @return EOK on success, EIO on I/O error
+ */
+int table_print_out(table_t *table, FILE *f)
+{
+	table_row_t *row;
+	table_cell_t *cell;
+	table_column_t *column;
+	bool firstc;
+	bool firstr;
+	size_t spacing;
+	size_t i;
+	int rc;
+
+	if (table->error != EOK)
+		return table->error;
+
+	row = table_row_first(table);
+	firstr = true;
+	while (row != NULL) {
+		cell = table_row_cell_first(row);
+		if (cell == NULL)
+			break;
+
+		column = table_column_first(table);
+		firstc = true;
+
+		while (cell != NULL && cell->text != NULL) {
+			spacing = firstc ? table->metrics.margin_left : 1;
+			for (i = 0; i < spacing; i++) {
+				rc = fprintf(f, " ");
+				if (rc < 0)
+					return EIO;
+			}
+
+			rc = fprintf(f, "%*s", -(int)column->width, cell->text);
+			if (rc < 0)
+				return EIO;
+
+			cell = table_row_cell_next(cell);
+			column = table_column_next(column);
+			firstc = false;
+		}
+		rc = fprintf(f, "\n");
+		if (rc < 0)
+			return EIO;
+
+		if (firstr && table->header_row) {
+			/* Display header separator */
+			column = table_column_first(table);
+			firstc = true;
+			while (column != NULL) {
+				spacing = firstc ? table->metrics.margin_left : 1;
+				for (i = 0; i < spacing; i++) {
+					rc = fprintf(f, " ");
+					if (rc < 0)
+						return EIO;
+				}
+
+				for (i = 0; i < column->width; i++) {
+					rc = fprintf(f, "=");
+					if (rc < 0)
+						return EIO;
+				}
+
+				column = table_column_next(column);
+				firstc = false;
+			}
+
+			rc = fprintf(f, "\n");
+			if (rc < 0)
+				return EIO;
+		}
+
+		row = table_row_next(row);
+		firstr = false;
+	}
+	return EOK;
+}
+
+/** Start a header row.
+ *
+ * @param table Table
+ */
+void table_header_row(table_t *table)
+{
+	assert(list_count(&table->rows) == 1);
+	assert(!table->header_row);
+	table->header_row = true;
+}
+
+/** Insert text into table cell(s).
+ *
+ * Appends text to the current cell. A tab character starts a new cell.
+ * A newline character starts a new row.
+ *
+ * @param table Table
+ * @param fmt Format string
+ * @return EOK on success, ENOMEM if out of memory
+ */
+int table_printf(table_t *table, const char *fmt, ...)
+{
+	va_list args;
+	int rc;
+	char *str;
+	char *sp, *ep;
+	size_t width;
+
+	if (table->error != EOK)
+		return table->error;
+
+	va_start(args, fmt);
+	rc = vasprintf(&str, fmt, args);
+	va_end(args);
+
+	if (rc < 0) {
+		table->error = ENOMEM;
+		return table->error;
+	}
+
+	sp = str;
+	while (*sp != '\0' && table->error == EOK) {
+		ep = sp;
+		while (*ep != '\0' && *ep != '\t' && *ep != '\n')
+			++ep;
+
+		if (table->wcell == NULL) {
+			rc = table_write_next_cell(table);
+			if (rc != EOK) {
+				assert(rc == ENOMEM);
+				goto out;
+			}
+		}
+
+		rc = table_cell_extend(table->wcell, sp, ep - sp);
+		if (rc != EOK) {
+			assert(rc == ENOMEM);
+			table->error = ENOMEM;
+			goto out;
+		}
+
+		/* Update column width */
+		width = str_width(table->wcell->text);
+		if (width > table->wcolumn->width)
+			table->wcolumn->width = width;
+
+		if (*ep == '\t')
+			rc = table_write_next_cell(table);
+		else if (*ep == '\n')
+			rc = table_write_next_row(table);
+		else
+			break;
+
+		if (rc != EOK) {
+			assert(rc == ENOMEM);
+			table->error = ENOMEM;
+			goto out;
+		}
+
+		sp = ep + 1;
+	}
+
+	rc = table->error;
+out:
+	free(str);
+	return rc;
+}
+
+/** Return table error code.
+ *
+ * @param table Table
+ * @return EOK if no error indicated, non-zero error code otherwise
+ */
+int table_get_error(table_t *table)
+{
+	return table->error;
+}
+
+/** Set left table margin.
+ *
+ * @param table Table
+ * @param mleft Left margin
+ */
+void table_set_margin_left(table_t *table, size_t mleft)
+{
+	table->metrics.margin_left = mleft;
+}
+
+/** @}
+ */
Index: uspace/lib/c/generic/io/visualizer.c
===================================================================
--- uspace/lib/c/generic/io/visualizer.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/generic/io/visualizer.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -33,4 +33,5 @@
  */
 
+#include <assert.h>
 #include <errno.h>
 #include <as.h>
@@ -175,9 +176,8 @@
 	sysarg_t x_offset, sysarg_t y_offset)
 {
-#ifdef __32_BITS__
+	assert(x_offset <= UINT16_MAX);
+	assert(y_offset <= UINT16_MAX);
+
 	sysarg_t offsets = ((x_offset << 16) | (y_offset & 0x0000ffff));
-#else
-	sysarg_t offsets = ((x_offset << 32) | (y_offset & 0xffffffff));
-#endif
 
 	async_exch_t *exch = async_exchange_begin(sess);
Index: uspace/lib/c/generic/irc.c
===================================================================
--- uspace/lib/c/generic/irc.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/generic/irc.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,8 +35,10 @@
 #include <assert.h>
 #include <errno.h>
+#include <fibril_synch.h>
 #include <ipc/irc.h>
 #include <ipc/services.h>
 #include <irc.h>
-#include <ns.h>
+#include <loc.h>
+#include <stdlib.h>
 #include <sysinfo.h>
 
@@ -49,7 +51,31 @@
 static int irc_init(void)
 {
+	category_id_t irc_cat;
+	service_id_t *svcs;
+	size_t count;
+	int rc;
+
 	assert(irc_sess == NULL);
+	rc = loc_category_get_id("irc", &irc_cat, IPC_FLAG_BLOCKING);
+	if (rc != EOK)
+		return EIO;
 
-	irc_sess = service_connect_blocking(SERVICE_IRC, INTERFACE_IRC, 0);
+	while (true) {
+		rc = loc_category_get_svcs(irc_cat, &svcs, &count);
+		if (rc != EOK)
+			return EIO;
+
+		if (count > 0)
+			break;
+
+		free(svcs);
+
+		// XXX This is just a temporary hack
+		fibril_usleep(500 * 1000);
+	}
+
+	irc_sess = loc_service_connect(svcs[0], INTERFACE_IRC,
+	    IPC_FLAG_BLOCKING);
+	free(svcs);
 
 	if (irc_sess == NULL)
@@ -60,4 +86,6 @@
 
 /** Enable interrupt.
+ *
+ * Allow interrupt delivery.
  *
  * @param irq	IRQ number
@@ -80,10 +108,35 @@
 }
 
-
 /** Disable interrupt.
+ *
+ * Disallow interrupt delivery.
  *
  * @param irq	IRQ number
  */
 int irc_disable_interrupt(int irq)
+{
+	int rc;
+
+	if (irc_sess == NULL) {
+		rc = irc_init();
+		if (rc != EOK)
+			return rc;
+	}
+
+	async_exch_t *exch = async_exchange_begin(irc_sess);
+	rc = async_req_1_0(exch, IRC_DISABLE_INTERRUPT, irq);
+	async_exchange_end(exch);
+
+	return rc;
+}
+
+/** Clear interrupt.
+ *
+ * Clear/acknowledge interrupt in interrupt controller so that
+ * another interrupt can be delivered.
+ *
+ * @param irq	IRQ number
+ */
+int irc_clear_interrupt(int irq)
 {
 	int rc;
Index: uspace/lib/c/generic/irq.c
===================================================================
--- uspace/lib/c/generic/irq.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/generic/irq.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -55,32 +55,29 @@
  *
  * @param inr    IRQ number.
- * @param devno  Device number of the device generating inr.
  * @param method Use this method for notifying me.
  * @param ucode  Top-half pseudocode handler.
+ *
+ * @return IRQ capability handle returned by the kernel.
+ * @return Error code returned by the kernel.
+ *
+ */
+int ipc_irq_subscribe(int inr, sysarg_t method, const irq_code_t *ucode)
+{
+	if (ucode == NULL)
+		ucode = &default_ucode;
+	
+	return __SYSCALL3(SYS_IPC_IRQ_SUBSCRIBE, inr, method, (sysarg_t) ucode);
+}
+
+/** Unsubscribe from IRQ notification.
+ *
+ * @param cap   IRQ capability handle.
  *
  * @return Value returned by the kernel.
  *
  */
-int ipc_irq_subscribe(int inr, int devno, sysarg_t method,
-    const irq_code_t *ucode)
+int ipc_irq_unsubscribe(int cap)
 {
-	if (ucode == NULL)
-		ucode = &default_ucode;
-	
-	return __SYSCALL4(SYS_IPC_IRQ_SUBSCRIBE, inr, devno, method,
-	    (sysarg_t) ucode);
-}
-
-/** Unsubscribe from IRQ notification.
- *
- * @param inr   IRQ number.
- * @param devno Device number of the device generating inr.
- *
- * @return Value returned by the kernel.
- *
- */
-int ipc_irq_unsubscribe(int inr, int devno)
-{
-	return __SYSCALL2(SYS_IPC_IRQ_UNSUBSCRIBE, inr, devno);
+	return __SYSCALL1(SYS_IPC_IRQ_UNSUBSCRIBE, cap);
 }
 
Index: uspace/lib/c/generic/ns.c
===================================================================
--- uspace/lib/c/generic/ns.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/generic/ns.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,25 +40,49 @@
 #include "private/ns.h"
 
+/*
+ * XXX ns does not know about session_ns, so we create an extra session for
+ * actual communicaton
+ */
+static async_sess_t *sess_ns = NULL;
+
 int service_register(service_t service)
 {
-	async_exch_t *exch = async_exchange_begin(session_ns);
+	sysarg_t retval;
+	ipc_call_t answer;
+	
+	async_sess_t *sess = ns_session_get();
+	if (sess == NULL)
+		return EIO;
+	
+	async_exch_t *exch = async_exchange_begin(sess);
+	aid_t req = async_send_1(exch, NS_REGISTER, service, &answer);
 	int rc = async_connect_to_me(exch, 0, service, 0);
+	
 	async_exchange_end(exch);
 	
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+	
+	async_wait_for(req, &retval);
 	return rc;
 }
 
-
 async_sess_t *service_connect(service_t service, iface_t iface, sysarg_t arg3)
 {
-	async_exch_t *exch = async_exchange_begin(session_ns);
-	if (!exch)
+	async_sess_t *sess = ns_session_get();
+	if (sess == NULL)
 		return NULL;
 	
-	async_sess_t *sess =
+	async_exch_t *exch = async_exchange_begin(sess);
+	if (exch == NULL)
+		return NULL;
+	
+	async_sess_t *csess =
 	    async_connect_me_to_iface(exch, iface, service, arg3);
 	async_exchange_end(exch);
 	
-	if (!sess)
+	if (csess == NULL)
 		return NULL;
 	
@@ -68,7 +92,7 @@
 	 * first argument for non-initial connections.
 	 */
-	async_sess_args_set(sess, iface, arg3, 0);
+	async_sess_args_set(csess, iface, arg3, 0);
 	
-	return sess;
+	return csess;
 }
 
@@ -76,10 +100,14 @@
     sysarg_t arg3)
 {
-	async_exch_t *exch = async_exchange_begin(session_ns);
-	async_sess_t *sess =
+	async_sess_t *sess = ns_session_get();
+	if (sess == NULL)
+		return NULL;
+	
+	async_exch_t *exch = async_exchange_begin(sess);
+	async_sess_t *csess =
 	    async_connect_me_to_blocking_iface(exch, iface, service, arg3);
 	async_exchange_end(exch);
 	
-	if (!sess)
+	if (csess == NULL)
 		return NULL;
 	
@@ -89,7 +117,7 @@
 	 * first argument for non-initial connections.
 	 */
-	async_sess_args_set(sess, iface, arg3, 0);
+	async_sess_args_set(csess, iface, arg3, 0);
 	
-	return sess;
+	return csess;
 }
 
@@ -97,5 +125,9 @@
 int ns_ping(void)
 {
-	async_exch_t *exch = async_exchange_begin(session_ns);
+	async_sess_t *sess = ns_session_get();
+	if (sess == NULL)
+		return EIO;
+	
+	async_exch_t *exch = async_exchange_begin(sess);
 	int rc = async_req_0_0(exch, NS_PING);
 	async_exchange_end(exch);
@@ -106,5 +138,10 @@
 int ns_intro(task_id_t id)
 {
-	async_exch_t *exch = async_exchange_begin(session_ns);
+	async_exch_t *exch;
+	async_sess_t *sess = ns_session_get();
+	if (sess == NULL)
+		return EIO;
+	
+	exch = async_exchange_begin(sess);
 	int rc = async_req_2_0(exch, NS_ID_INTRO, LOWER32(id), UPPER32(id));
 	async_exchange_end(exch);
@@ -113,4 +150,19 @@
 }
 
+async_sess_t *ns_session_get(void)
+{
+	async_exch_t *exch;
+	
+	if (sess_ns == NULL) {
+		exch = async_exchange_begin(session_ns);
+		sess_ns = async_connect_me_to_iface(exch, 0, 0, 0);
+		async_exchange_end(exch);
+		if (sess_ns == NULL)
+			return NULL;
+	}
+	
+	return sess_ns;
+}
+
 /** @}
  */
Index: uspace/lib/c/generic/perm.c
===================================================================
--- uspace/lib/c/generic/perm.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/c/generic/perm.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,83 @@
+/*
+ * Copyright (c) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/**
+ * @file  perm.c
+ * @brief Functions to grant/revoke permissions to/from a task.
+ */
+
+#include <perm.h>
+#include <task.h>
+#include <libc.h>
+#include <types/common.h>
+
+/** Grant permissions to a task.
+ *
+ * @param id    Destination task ID.
+ * @param perms Permissions to grant.
+ *
+ * @return Zero on success or a value from @ref errno.h on failure.
+ *
+ */
+int perm_grant(task_id_t id, unsigned int perms)
+{
+#ifdef __32_BITS__
+	sysarg64_t arg = (sysarg64_t) id;
+	return __SYSCALL2(SYS_PERM_GRANT, (sysarg_t) &arg, (sysarg_t) perms);
+#endif
+	
+#ifdef __64_BITS__
+	return __SYSCALL2(SYS_PERM_GRANT, (sysarg_t) id, (sysarg_t) perms);
+#endif
+}
+
+/** Revoke permissions from a task.
+ *
+ * @param id    Destination task ID.
+ * @param perms Permissions to revoke.
+ *
+ * @return Zero on success or a value from @ref errno.h on failure.
+ *
+ */
+int perm_revoke(task_id_t id, unsigned int perms)
+{
+#ifdef __32_BITS__
+	sysarg64_t arg = (sysarg64_t) id;
+	return __SYSCALL2(SYS_PERM_REVOKE, (sysarg_t) &arg, (sysarg_t) perms);
+#endif
+	
+#ifdef __64_BITS__
+	return __SYSCALL2(SYS_PERM_REVOKE, (sysarg_t) id, (sysarg_t) perms);
+#endif
+}
+
+/** @}
+ */
Index: uspace/lib/c/generic/qsort.c
===================================================================
--- uspace/lib/c/generic/qsort.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/c/generic/qsort.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,214 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+
+/**
+ * @file
+ * @brief Quicksort.
+ */
+
+#include <qsort.h>
+#include <stdbool.h>
+#include <stddef.h>
+
+/** Quicksort spec */
+typedef struct {
+	void *base;
+	size_t nmemb;
+	size_t size;
+	int (*compar)(const void *, const void *, void *);
+	void *arg;
+} qs_spec_t;
+
+/** Comparison function wrapper.
+ *
+ * Performs qsort_r comparison using qsort comparison function
+ *
+ * @param a First element
+ * @param b Second element
+ * @param arg qsort comparison function
+ */
+static int compar_wrap(const void *a, const void *b, void *arg)
+{
+	int (*compar)(const void *, const void *) =
+	    (int (*)(const void *, const void *))arg;
+
+	return compar(a, b);
+}
+
+/** Determine if one element is less-than another element.
+ *
+ * @param qs Quicksort spec
+ * @param i First element index
+ * @param j Second element index
+ */
+static bool elem_lt(qs_spec_t *qs, size_t i, size_t j)
+{
+	const void *a;
+	const void *b;
+	int r;
+
+	a = qs->base + i * qs->size;
+	b = qs->base + j * qs->size;
+
+	r = qs->compar(a, b, qs->arg);
+
+	return r < 0;
+}
+
+/** Swap two elements.
+ *
+ * @param qs Quicksort spec
+ * @param i First element index
+ * @param j Second element index
+ */
+static void elem_swap(qs_spec_t *qs, size_t i, size_t j)
+{
+	char *a;
+	char *b;
+	char t;
+	size_t k;
+
+	a = qs->base + i * qs->size;
+	b = qs->base + j * qs->size;
+
+	for (k = 0; k < qs->size; k++) {
+		t = a[k];
+		a[k] = b[k];
+		b[k] = t;
+	}
+}
+
+/** Partition a range of indices.
+ *
+ * @param qs Quicksort spec
+ * @param lo Lower bound (inclusive)
+ * @param hi Upper bound (inclusive)
+ * @return Pivot index
+ */
+static size_t partition(qs_spec_t *qs, size_t lo, size_t hi)
+{
+	size_t pivot;
+	size_t i, j;
+
+	pivot = lo + (hi - lo) / 2;
+	i = lo;
+	j = hi;
+	while (true) {
+		while (elem_lt(qs, i, pivot))
+			++i;
+		while (elem_lt(qs, pivot, j))
+			--j;
+
+		if (i >= j)
+			return j;
+
+		elem_swap(qs, i, j);
+
+		/* Need to follow pivot movement */
+		if (i == pivot)
+			pivot = j;
+		else if (j == pivot)
+			pivot = i;
+
+		i++;
+		j--;
+	}
+}
+
+/** Sort a range of indices.
+ *
+ * @param qs Quicksort spec
+ * @param lo Lower bound (inclusive)
+ * @param hi Upper bound (inclusive)
+ */
+static void quicksort(qs_spec_t *qs, size_t lo, size_t hi)
+{
+	size_t p;
+
+	if (lo < hi) {
+		p = partition(qs, lo, hi);
+		quicksort(qs, lo, p);
+		quicksort(qs, p + 1, hi);
+	}
+}
+
+/** Quicksort.
+ *
+ * @param base Array to sort
+ * @param nmemb Number of array members
+ * @param size Size of member in bytes
+ * @param compar Comparison function
+ */
+void qsort(void *base, size_t nmemb, size_t size, int (*compar)(const void *,
+    const void *))
+{
+	qs_spec_t qs;
+
+	if (nmemb == 0)
+		return;
+
+	qs.base = base;
+	qs.nmemb = nmemb;
+	qs.size = size;
+	qs.compar = compar_wrap;
+	qs.arg = compar;
+
+	quicksort(&qs, 0, nmemb - 1);
+}
+
+/** Quicksort with extra argument to comparison function.
+ *
+ * @param base Array to sort
+ * @param nmemb Number of array members
+ * @param size Size of member in bytes
+ * @param compar Comparison function
+ * @param arg Argument to comparison function
+ */
+void qsort_r(void *base, size_t nmemb, size_t size, int (*compar)(const void *,
+    const void *, void *), void *arg)
+{
+	qs_spec_t qs;
+
+	if (nmemb == 0)
+		return;
+
+	qs.base = base;
+	qs.nmemb = nmemb;
+	qs.size = size;
+	qs.compar = compar;
+	qs.arg = arg;
+
+	quicksort(&qs, 0, nmemb - 1);
+}
+
+/** @}
+ */
Index: uspace/lib/c/generic/rtld/dynamic.c
===================================================================
--- uspace/lib/c/generic/rtld/dynamic.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/generic/rtld/dynamic.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
 
 #include <stdio.h>
+#include <inttypes.h>
 
 #include <rtld/elf_dyn.h>
@@ -105,13 +106,13 @@
 	info->dynamic = dyn_ptr;
 
-	DPRINTF("str_tab=0x%x, soname_idx=0x%x, soname=0x%x\n",
+	DPRINTF("str_tab=0x%" PRIxPTR ", soname_idx=0x%x, soname=0x%" PRIxPTR "\n",
 		(uintptr_t)info->soname, soname_idx, (uintptr_t)info->soname);
 	DPRINTF("soname='%s'\n", info->soname);
 	DPRINTF("rpath='%s'\n", info->rpath);
-	DPRINTF("hash=0x%x\n", (uintptr_t)info->hash);
-	DPRINTF("dt_rela=0x%x\n", (uintptr_t)info->rela);
-	DPRINTF("dt_rela_sz=0x%x\n", (uintptr_t)info->rela_sz);
-	DPRINTF("dt_rel=0x%x\n", (uintptr_t)info->rel);
-	DPRINTF("dt_rel_sz=0x%x\n", (uintptr_t)info->rel_sz);
+	DPRINTF("hash=0x%" PRIxPTR "\n", (uintptr_t)info->hash);
+	DPRINTF("dt_rela=0x%" PRIxPTR "\n", (uintptr_t)info->rela);
+	DPRINTF("dt_rela_sz=0x%" PRIxPTR "\n", (uintptr_t)info->rela_sz);
+	DPRINTF("dt_rel=0x%" PRIxPTR "\n", (uintptr_t)info->rel);
+	DPRINTF("dt_rel_sz=0x%" PRIxPTR "\n", (uintptr_t)info->rel_sz);
 
 	/*
Index: uspace/lib/c/generic/rtld/module.c
===================================================================
--- uspace/lib/c/generic/rtld/module.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/generic/rtld/module.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -192,5 +192,5 @@
 
 	DPRINTF("filename:'%s'\n", name_buf);
-	DPRINTF("load '%s' at 0x%x\n", name_buf, m->bias);
+	DPRINTF("load '%s' at 0x%zx\n", name_buf, m->bias);
 
 	rc = elf_load_file_name(name_buf, m->bias, ELDF_RW, &info);
Index: uspace/lib/c/generic/str.c
===================================================================
--- uspace/lib/c/generic/str.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/generic/str.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -995,4 +995,24 @@
 	dest[idx] = '\0';
 	return rc;
+}
+
+/** Get size of UTF-16 string.
+ *
+ * Get the number of words which are used by the UTF-16 string @a ustr
+ * (excluding the NULL-terminator).
+ *
+ * @param ustr UTF-16 string to consider.
+ *
+ * @return Number of words used by the UTF-16 string
+ *
+ */
+size_t utf16_wsize(const uint16_t *ustr)
+{
+	size_t wsize = 0;
+
+	while (*ustr++ != 0)
+		wsize++;
+
+	return wsize;
 }
 
Index: uspace/lib/c/generic/task.c
===================================================================
--- uspace/lib/c/generic/task.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/generic/task.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -44,4 +44,5 @@
 #include <async.h>
 #include <errno.h>
+#include <ns.h>
 #include <malloc.h>
 #include <libc.h>
@@ -324,5 +325,9 @@
 int task_setup_wait(task_id_t id, task_wait_t *wait)
 {
-	async_exch_t *exch = async_exchange_begin(session_ns);
+	async_sess_t *sess_ns = ns_session_get();
+	if (sess_ns == NULL)
+		return EIO;
+
+	async_exch_t *exch = async_exchange_begin(sess_ns);
 	wait->aid = async_send_2(exch, NS_TASK_WAIT, LOWER32(id), UPPER32(id),
 	    &wait->result);
@@ -401,5 +406,9 @@
 int task_retval(int val)
 {
-	async_exch_t *exch = async_exchange_begin(session_ns);
+	async_sess_t *sess_ns = ns_session_get();
+	if (sess_ns == NULL)
+		return EIO;
+
+	async_exch_t *exch = async_exchange_begin(sess_ns);
 	int rc = (int) async_req_1_0(exch, NS_RETVAL, val);
 	async_exchange_end(exch);
